#include <bits/stdc++.h>
using namespace std;

int main(int argc, char**argv){
ios::sync_with_stdio(false); cin.tie(0); cout.tie(0);
long long n, q; cin >> n;
long long x[n], y[n], p[n];
for ( int i = 1; i < n; i++ ){
    cin >> x[i] >> y[i];
}
for ( int i = 0; i < n; i++ ){
    cin >> p[i];
}
cin >> q;
long long z[q], b[q];
for ( int i = 0; i < q; i++ ){
    cin >> z[i] >> b[i];
}

if ( q == 0 ){
    long long v[n];
    for ( int i = 0; i < n; i++ ){
        v[i] = p[i];
    }
    sort(v, v+n);
    long long poz = 0;
    while( v[n-1] > p[poz] ){
        poz++;
    }
    cout << poz + 1;
}

return 0;
}